Program Ut;
{Ertekel a UT feladathoz}
Uses TestLib;
{Importlt elemek:
TCase:Integer;           a tesztesetek szma
Function DoTest:Boolean; a teszteset rtkelhet, van output fjl
Procedure Done;          az rtkels vgnek jelzse
Procedure Grade(rf, v:Integer); az rf rszfeladat rtklse, v=0/1
                                ha nem hvjuk, 0 rtket kap a teszeset
Procedure WriteMSG(rf:Integer; M:String); az rf rszfeladat rtkelsnekmagyarzata
            ha nem hvjuk, resen marad
TInF:Text;  teszt input, megnyitva
ToutF:Text; teszt output, megnyitva
CoutF:Text; a versenyz output llomnya, megnyitva
}
Var
  t:Integer;

Procedure Eval;
Const
  MaxN=10000;
Type
  Szinek=(Feher, Szurke, Fekete);
  Pont=1..MaxN;
  List=^Cell;
  Cell=Record P:Pont; link:List End;
  Graph=Array[1..MaxN] Of List;
Var
  G:Graph;      {input graph}
  K,N,M:Word;     {# graph Ponts}
  Szin:Array[Pont] of Szinek;
  El:Array[Pont] of Record u,v:Pont; s:Longint End;
  Meg1,Meg2,VMeg1,VMeg2:Longint;
  u,v,i,j,s:Longint;
  Guv:List;
  Kolts:Longint;

  Procedure MelyBejar(u:Pont);
  {Global: }
  Var
    El:List;
    v:Pont;
  Begin
    Szin[u]:=Szurke;
    El:=G[u];
    While El<>Nil Do Begin{processing edge u->v }
      v:=El^.p;
      If Szin[v]=Feher Then Begin
        MelyBejar(v);
      End;
    End{while u->v};
    Szin[u]:=Fekete;
  End{MelyBejar};

Begin{Eval}
  ReadLn(Tinf,N,M,K);
  For u:=1 To N Do Begin       {Init}
    G[u]:=Nil;
  End;
  For i:=1 To M Do Begin       {Read input}
    ReadLn(TInF, u,v,s);
    El[i].u:=u; El[i].v:=v; El[i].s:=s;
    If i<=K Then Begin
      New(Guv);
      Guv^.p:=v; Guv^.link:=G[u];
      G[u]:=Guv;
      New(Guv);
      Guv^.p:=u; Guv^.link:=G[v];
      G[v]:=Guv;
    End;
  End{for i};
  ReadLn(ToutF,Meg1);
  ReadLn(ToutF,Meg2);

  {$I-}
     ReadLn(CoutF, VMeg1);
  {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(1,'HIBA: Output formtum hiba');
      Exit;
   End;
   If Meg1<>VMeg1 Then Begin
     WriteMSG(1,'HIBA: A helyes eredmeny '+InttoStr(Meg1)+' es nem '+InttoStr(VMeg1));
     Exit;
   End;
  Grade(1,1);
  WriteMSG(1,'HELYES');

  {$I-}
     ReadLn(CoutF, VMeg2);
  {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(2,'HIBA: Output formtum hiba');
      Exit;
   End;
   If Meg2<>VMeg2 Then Begin
     WriteMSG(2,'HIBA: A helyes eredmeny '+InttoStr(Meg2)+' es nem '+InttoStr(VMeg2));
     Exit;
   End;

  Kolts:=0;
  For i:=1 To meg2 Do Begin
    If SeekEoln(CoutF) Then Begin
     WriteMSG(2,'HIBA: Kevesebb szmot ir ki');
      Exit;
   End;
  {$I-}
     Read(CoutF, j);
  {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(2,'HIBA: Output formtum hiba');
      Exit;
   End;
   If (j<1)Or(j>N) Then Begin
     WriteMSG(2,'HIBA: Hibs sorszm: '+InttoStr(j));
     Exit;
   End;
   Kolts:=Kolts+El[j].s;
   New(Guv);
   Guv^.p:=El[j].v; Guv^.link:=G[El[j].u];
   G[El[j].u]:=Guv;
   New(Guv);
   Guv^.p:=El[j].u; Guv^.link:=G[El[j].v];
   G[El[j].v]:=Guv;   
  End{for i};

  If Kolts<>Meg1 Then Begin
     WriteMSG(2,'HIBA: Hibs az sszkltsg');
     Exit;
  End;

  For u:=1 To N Do Szin[u]:=Feher;
  MelyBejar(1);
  For u:=1 To N Do If Szin[u]<>Fekete Then Begin
    WriteMSG(2,'HIBA: Hibs a fesztfa');
    Exit;
  End;

  Grade(2,1);
  WriteMSG(2,'HELYES');
End{Eval};

Begin{Prog}
  For t:=1 To TCase Do Begin
    If DoTest Then
      Eval;
  End;
  Done;
End.
